#ifndef _UTILS_LOG_H_
#define _UTILS_LOG_H_

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#ifdef USE_ANDROID_LOG
#include <android/log.h>

#define LOG_TAG "zkgui"
#define LOGE(...)  __android_log_print(ANDROID_LOG_ERROR,LOG_TAG,__VA_ARGS__)
#define LOGD(...)  __android_log_print(ANDROID_LOG_DEBUG,LOG_TAG,__VA_ARGS__)
#else
#define LOGE(fmt,...)	{\
    time_t now = time(NULL); \
    struct tm t; \
    localtime_r(&now, &t); \
    struct timespec ts; \
    clock_gettime(CLOCK_BOOTTIME, &ts); \
    fprintf(stderr, "%02d:%02d:%02d.%03ld ERROR ", \
        t.tm_hour, t.tm_min, t.tm_sec, (ts.tv_nsec / 1000000)); \
    fprintf(stderr,fmt,##__VA_ARGS__); \
    fprintf(stderr,"\n"); \
  }
#define LOGD(fmt,...) 	    {\
    time_t now = time(NULL); \
    struct tm t; \
    localtime_r(&now, &t); \
    struct timespec ts; \
    clock_gettime(CLOCK_BOOTTIME, &ts); \
    fprintf(stderr, "%02d:%02d:%02d.%03ld DEBUG ", \
        t.tm_hour, t.tm_min, t.tm_sec, (ts.tv_nsec / 1000000)); \
    fprintf(stderr,fmt,##__VA_ARGS__); \
    fprintf(stderr,"\n"); \
  }
#endif

#if 0

#define ZKSWE_DEBUG_EASYGUI
#ifdef ZKSWE_DEBUG_EASYGUI
#include <sys/time.h>
#define TIME_ELAPSED(codeToTime) do { \
    struct timeval beginTime, endTime; \
    gettimeofday(&beginTime, NULL); \
    { codeToTime; } \
    gettimeofday(&endTime, NULL); \
    long secTime  = endTime.tv_sec - beginTime.tv_sec; \
    long usecTime = endTime.tv_usec - beginTime.tv_usec; \
	if (secTime) { \
		long secTime1 = (secTime*1000000 + endTime.tv_usec - beginTime.tv_usec)/1000000; \
		usecTime = (secTime*1000000 + endTime.tv_usec - beginTime.tv_usec)%1000000; \
		fprintf(stderr, "[%s(%d)]Elapsed Time: SecTime = %lds, UsecTime = %ldus!\n", __FUNCTION__, __LINE__, secTime1, usecTime); \
	} else \
		fprintf(stderr, "[%s(%d)]Elapsed Time: SecTime = %lds, UsecTime = %ldus!\n", __FUNCTION__, __LINE__, secTime, usecTime); \
} while (0)
#else
#define TIME_ELAPSED(codeToTime) do { \
	{ codeToTime; } \
} while (0)
#endif

#endif

#endif /* _UTILS_LOG_H_ */
